#include <sourcemod>
#include <dhooks>
#include <profiler>

public Plugin myinfo =
{
	name = "Anti Server Lag Exploits",
	author = "backwards",
	description = "Adds the net_chan_limit_msec functionality from csgo to other source games to help prevent server lag exploits.",
	version = "1.0",
	url = "http://www.steamcommunity.com/id/mypassword"
}

Handle hProcessPacketDetour, PP, hPlayerSlot;
float TotalProcessingTime[MAXPLAYERS+1] = 0.0;
Address m_MessageHandler;
ConVar net_chan_limit_msec;

public OnPluginStart()
{
	Handle hGameData = LoadGameConfigFile("AntiServerLagExploits");
	
	if (!hGameData)
		SetFailState("Failed to load AntiServerLagExploits gamedata.");

	m_MessageHandler = view_as<Address>(GameConfGetOffset(hGameData, "m_MessageHandler"));
	
	hProcessPacketDetour = DHookCreateFromConf(hGameData, "ProcessPacket");
	
	if (!hProcessPacketDetour)
		SetFailState("Failed to setup detour for ProcessPacket");
	
	if (!DHookEnableDetour(hProcessPacketDetour, false, Detour_ProcessPacket))
		SetFailState("Failed to detour ProcessPacket.");
	
	if (!DHookEnableDetour(hProcessPacketDetour, true, Detour_ProcessPacketPost))
		SetFailState("Failed to detour ProcessPacketPost.");
	
	StartPrepSDKCall(SDKCall_Raw);
	PrepSDKCall_SetFromConf(hGameData, SDKConf_Virtual, "CBaseClient::GetPlayerSlot");
	PrepSDKCall_SetReturnInfo(SDKType_PlainOldData, SDKPass_Plain);
	hPlayerSlot = EndPrepSDKCall();
	
	if(hPlayerSlot == INVALID_HANDLE)
		SetFailState("Failed to setup sdkcall for CBaseClient::GetPlayerSlot.");
	
	delete hGameData;
	
	net_chan_limit_msec = CreateConVar("net_chan_limit_msec", "20", "max limit packets processing time in ms.", FCVAR_NONE);
	PP = CreateProfiler();
	CreateTimer(1.0, ShowInfoToPlayersAndPunish, _, TIMER_REPEAT);
} 

public MRESReturn Detour_ProcessPacket(Address pThis, Handle hReturn, Handle hParams)
{
    StartProfiling(PP);
    return MRES_Ignored;
}

public MRESReturn Detour_ProcessPacketPost(Address pThis, Handle hReturn, Handle hParams)
{
	StopProfiling(PP);

	Address IClient = view_as<Address>(LoadFromAddress(pThis + m_MessageHandler, NumberType_Int32));

	//IClient Not Accessible. 
	if(IClient == view_as<Address>(0x0))
		return MRES_Ignored;
	
	int client = view_as<int>(SDKCall(hPlayerSlot, IClient)) + 1;
	TotalProcessingTime[client] += GetProfilerTime(PP);
	
	//Kick instantly for really affective exploits.
	if(GetProfilerTime(PP) > net_chan_limit_msec.FloatValue / 1000)
	{
		if(net_chan_limit_msec.FloatValue == 0.0)
			return MRES_Ignored;
		
		PrintToServer("[Anti-Server-Lag-Exploits]: Kicked '%N' for having a packet processing time of %f seconds.", client, TotalProcessingTime[client]);
		KickClientEx(client, "[Anti-Server-Lag-Exploits]: Attempted Lag Spike.");
	} 
	
	return MRES_Ignored;
}

public Action ShowInfoToPlayersAndPunish(Handle:timer)
{
	for(int i = 1;i<MaxClients+1;i++)
	{
		if(net_chan_limit_msec.FloatValue == 0.0)
		{
			TotalProcessingTime[i] = 0.0;
			continue;
		}
		
		if(IsClientConnected(i) && !IsFakeClient(i))
		{
			if(TotalProcessingTime[i] > net_chan_limit_msec.FloatValue / 1000)
			{
				PrintToServer("[Anti-Server-Lag-Exploits]: Kicked '%N' for having a packet processing time of %f seconds.", i, TotalProcessingTime[i]);
				KickClientEx(i, "[Anti-Server-Lag-Exploits]: Attempted Lag Spike.");
			}
			
			//if(IsClientInGame(i)) //debug
			//	PrintToChat(i, "Packet Processing Time = %f.", TotalProcessingTime[i]);
		}
		
		TotalProcessingTime[i] = 0.0;
	}
	
	return Plugin_Continue;
}